

using System.Collections.Generic;

namespace FMSAdmin.Models {
    public class PagingRequest {
        public int page { get; set; } = 1;
        public int limit { get; set; } = 20;
        public Sort sort { get; set; }
        public Condition[] conditions { get; set; }

        // 엑셀다운로드 헤더매핑용
        public Column[] columns { get; set; }

        // 사이트ID (본사권한)
        public int? siteId { get; set; }
        // 사이트ID 여러개 (본사권한)
        public int[] siteIds { get; set; }

        // 업무분야ID (업무권한)
        public int? businessFieldId { get; set; }

        public class Sort {
            public string field { get; set; }
            public string order { get; set; }
        }
        public class Condition {
            public string field { get; set; }
            public string op { get; set; }
            public string value { get; set; }
        }
        public class Column {
            public string field { get; set; }
            public string name { get; set; }
            public string align { get; set; }
            public string format { get; set; }
        }
    }

}